
/*!
 * Jade - utils
 * Copyright(c) 2010 TJ Holowaychuk <tj@vision-media.ca>
 * MIT Licensed
 */

/**
 * Convert interpolation in the given string to JavaScript.
 *
 * @param {String} str
 * @return {String}
 * @api private
 */

var interpolate = exports.interpolate = function(str){
    return str.replace(/(\\)?[#$]{(.*?)}/g, function(str, escape, code){
        return escape
            ? str
            : "' + (" + code.replace(/\\'/g, "'") + ") + '";
    });
};

/**
 * Escape single quotes in `str`.
 *
 * @param {String} str
 * @return {String}
 * @api private
 */

var escape = exports.escape = function(str) {
    return str.replace(/'/g, "\\'");
};

/**
 * Interpolate, escape, and join lines in the given text `node`.
 *
 * @param {Text} node
 * @return {String}
 * @api private
 */

exports.text = function(node, newline){
    return interpolate(escape(node.join('\\n').trimLeft() + (newline ? '\\n' : '')));
};